<template>
	<view class="page">
		<view class="finishProductIn-locno-bg" />
		<u-navbar title="核磅记录" :background="background" :border-bottom="false" :title-bold="true" title-color="#000"
			back-icon-color="#000">
			<view class="navbar-right" slot="right" @click="goPrintAll">
				全部打印
			</view>
		</u-navbar>
		<view class="wrap">
			<scroll-view class="finishProductIn-locno-scroll-list" scroll-y="true" @scrolltolower="getmoreList()">
				<u-cell-group class="finishProductIn-locno-scroll-list-group" :border="false">
					<view class="content" v-for="(item, index) in list" :key="item.locNo" :index="index"
						@click="selectNo(item)">
						<view class="content-header">
							<view class="content-header-title">{{ index + 1 }}</view>
						</view>
						<view class="content-body">
							<view class="row-list">
								<view class="_label">
									<view class="_label-icon-1"> </view>
									<view class="_label-name">批次号：</view>
								</view>
								<view class="_content">
									{{ item.outBatchNo }}
								</view>
							</view>
							<view class="row-list">
								<view class="_label">
									<view class="_label-icon-2"> </view>
									<view class="_label-name">产品描述：</view>
								</view>
								<view class="_content">
									{{ item.netWeight }}
								</view>
							</view>
							<view class="row-list">
								<view class="_label">
									<view class="_label-icon-3"> </view>
									<view class="_label-name">零件号：</view>
								</view>
								<view class="_content">
									{{ item.partNo }}
								</view>
							</view>
							<view class="row-list">
								<view class="_label">
									<view class="_label-icon-1"> </view>
									<view class="_label-name">毛重：</view>
								</view>
								<view class="_content">
									{{ item.grossWeight }}
								</view>
							</view>
							<view class="row-list">
								<view class="_label">
									<view class="_label-icon-2"> </view>
									<view class="_label-name">盘重：</view>
								</view>
								<view class="_content">
									{{ item.trayWeight }}
								</view>
							</view>
							<view class="row-list">
								<view class="_label">
									<view class="_label-icon-3"> </view>
									<view class="_label-name">净重：</view>
								</view>
								<view class="_content">
									{{ item.value5 }}
								</view>
							</view>
							<view class="row-list">
								<view class="_label">
									<view class="_label-icon-1"> </view>
									<view class="_label-name">核磅重量：</view>
								</view>
								<view class="_content">
									{{ item.netWeight }}
								</view>
							</view>
							<view class="row-list">
								<view class="_label">
									<view class="_label-icon-2"> </view>
									<view class="_label-name">叉车盘重：</view>
								</view>
								<view class="_content">
									{{ item.value7 }}
								</view>
							</view>
						</view>
					</view>
				</u-cell-group>
				<view class="loadmore" @click="getmoreList()">
					<u-loadmore :status="status" :load-text="loadText" @loadmore="getmoreList()" />
				</view>
			</scroll-view>
		</view>
		<u-toast ref="uToast" />
		<u-modal v-model="maskShow" title="" v-for="(item, index) in listDevice" :key="index"
			:show-confirm-button="true" @confirm="tapQuery(item)">
			<view class="packing-registration-param-view" @touchmove.stop.prevent="moveHandle" @click="maskclose">
				<scroll-view class="uni-scroll_box" scroll-y @touchmove.stop.prevent="moveHandle"
					@click.stop="moveHandle">
					<view class="packing-registration-param-item param-extra">
						<view class="packing-registration-param-item-left">
							<text class="item-one">名称：</text>
						</view>
						<view class="packing-registration-param-item-right">
							<text class="item-one">{{ item.name }}</text>
						</view>
					</view>
					<view class="packing-registration-param-item param-extra">
						<view class="packing-registration-param-item-left">
							<text class="item-one">UUID:</text>
						</view>
						<view class="packing-registration-param-item-right">
							<text class="item-one">{{ item.address }}</text>

						</view>
					</view>
				</scroll-view>
			</view>
		</u-modal>
	</view>
</template>
<script>
	import content_bg from '@/static/custom/finishProductIn/locNoBg.png'
	const jcapi = uni.requireNativePlugin("JCSDK-JCApiModule");

	// 二维码类型
	const QrCodeType = {
		QrCode: 31,
		PDF417: 32,
		DataMatrix: 33,
		AZTEC: 34
	}
	// 线条类型
	const LineType = {
		Solid: 1, // 实线
		Dotted: 2, // 虚线（默认虚实1:1相间）
	}
	// 换行方式
	const LineModeType = {
		Justified: 1, // 宽高固定，内容自适应（字号/字间距/行间距按比例缩放）
		AutoHeight: 2, // 宽度固定，高度自适应
		Fixed: 4, // 宽高固定，超出部分裁剪
		Adapt: 6, // 宽高固定，内容超过时预设宽高自动缩小
	}
	export default {
		data() {
			return {
				background: {
					backgroundImage: `url(${content_bg})`,
					backgroundAttachment: 'fixed',
					backgroundSize: '100% auto',
					backgroundRepeat: 'no-repeat',
				},
				keywords: '',
				list: [],
				total: 0,
				pageNum: 1,
				pageSize: 10,
				status: 'loading',
				loadText: {
					loadmore: "加载更多...",
					loading: "努力加载中...",
					nomore: "没有更多了",
				},
				maskShow: false,
				listDevice: [], //蓝牙设备数据
				pritList: [],
				printDensity: 3, // 默认打印浓度
				labelType: 1, // 默认标签类型 *                  
				// 1：间隙纸
				// 2：黑标纸
				// 3：连续纸
				// 4：定孔纸
				// 5：透明纸
				printMode: 2, // 默认打印模式
				//	1：热敏
				// 	2：热转印
				connectedDevice: null // 已连接的打印机
			};
		},
		onLoad() {
			this.getlist()
			// 初始化SDK
			jcapi.initSDK()
			// 监听页码回调
			jcapi.didReadPrintCountInfo(function(r) {
				console.log(r)
			})

			// 监听错误回调
			jcapi.didReadPrintErrorInfo((r) => {
				console.log(r)
				if (r.code == 23) {
					// 打印机断开连接
					this.connectedDevice = null
					uni.showToast({
						icon: 'none',
						title: '打印机连接已断开，请重新连接',
						duration: 2 * 1000
					})
				} else {
					uni.showToast({
						icon: 'none',
						title: JSON.stringify(r),
						duration: 2 * 1000
					})
				}
			})
		},
		methods: {
			getmoreList() {
				if (this.pageSize >= this.total) {
					this.status = "nomore";
					return;
				}
				this.status = "loading";
				setTimeout(() => {
					this.pageSize += this.pageSize;
					this.getlist();
				}, 1000);
			},
			getlist() {
				this.$u.api.workReporting
					.getWorkshopOrder({
						current: this.pageNum,
						size: this.pageSize
					})
					.then((res) => {
						this.list = res.data.records;
						this.total = res.data.total;
						if (this.pageSize >= this.total) {
							this.status = "nomore";
						} else {
							this.status = "loadmore";
						}
					});
			},
			search(value) {
				if (value) {
					this.list = [];
					this.pageSize = 10;
					this.$u.api.workReporting
						.getWorkshopOrder({
							current: this.pageNum,
							size: this.pageSize,
							moNo: value,
						})
						.then((res) => {
							this.list = res.data.records;
							this.total = res.data.total;
							if (this.pageSize >= this.total) {
								this.status = "nomore";
							} else {
								this.status = "loadmore";
							}
						});
				} else {
					this.getlist();
				}
			},
			// 打印单个信息
			// 检查蓝牙连接状态
			async checkBluetoothConnection() {
				if (!this.connectedDevice) return false;
				
				// 尝试发送一个简单命令检查连接状态
				return new Promise(resolve => {
					jcapi.checkPrinterStatus(this.connectedDevice.address, r => {
						if (r && r.code === 0) {
							resolve(true);
						} else {
							// 连接已断开
							this.connectedDevice = null;
							resolve(false);
						}
					});
				});
			},

			selectNo(item) {
				let that = this
				uni.showModal({
					title: '提示',
					content: '是否打印装箱单？',
					showCancel: true,
					success: async function(res) {
						if (res.confirm) {
							// 检查蓝牙连接状态
							const isConnected = await that.checkBluetoothConnection();
							if (isConnected) {
								// 已连接，直接打印
								that.pritList = [item]
								that.pritList.forEach(async item => {
									await that.printQrCode(item)
								})
							} else {
								// 未连接或连接已断开，搜索设备
								that.searchDevice()
								that.pritList = [item]
							}
						}
					}
				});
			},
			// 打印全部信息
			goPrintAll() {
				let that = this
				uni.showModal({
					title: '提示',
					content: '是否打印装箱单？',
					showCancel: true,
					success: async function(res) {
						if (res.confirm) {
							// 检查蓝牙连接状态
							const isConnected = await that.checkBluetoothConnection();
							if (isConnected) {
								// 已连接，直接打印
								that.pritList = that.list
								that.pritList.forEach(async item => {
									await that.printQrCode(item)
								})
							} else {
								// 未连接或连接已断开，搜索设备
								that.searchDevice()
								that.pritList = that.list
							}
						}
					}
				});
			},
			moveHandle() {

			},
			maskclose() {

			},
			//打印二维码
			async printQrCode(item) {
				console.log('item de shuju ', item)
				const params = {
					rwMatlBindId: item.id
				};
				try {
				let res = await this.$u.api.dailyPaper.zongjianLabelInfo(params)
				if (!res.data) {
					this.$refs.uToast.show({
						title: '未查询到该标签信息！',
						type: 'warning '
					})
					return
				}
				// const res = {
				// 	ht: 'HT20250717995352665',
				// 	lj: '88.118.1/A0611091',
				// 	ljms: '铜单线 裸铜-TY-圆形-3.0',
				// 	fh: '1083.6',
				// 	scdt: '2025-07-14 13:46:55.0',
				// 	scph: '2025071273-3',
				// 	fhdw: '江东合金技术有限公司',
				// 	shdw: '昆山泰德通铜业有限公司',
				// }
				// 从API响应中提取所需数据
				const {
					ht,
					lj,
					ljms,
					fh,
					scdt,
					scph,
					fhdw,
					shdw
				} = res.data
				// const jsonString = JSON.stringify(res.data)

				// 初始化画板
				jcapi.initDrawingBoard({
					width: 70,
					height: 49,
					rotate: 90
				});

				// 绘制二维码
				const qrContent =
					`ht:${ht}\nlj:${lj}\nljms:${ljms}\nfh:${fh}\nscdt:${scdt}\nscph:${scph}\nfhdw:${fhdw}\nshdw:${shdw}`;
				jcapi.drawLabelQrCode({
					x: 43.5,
					y: 2,
					width: 24,
					height: 24,
					value: qrContent,
					rotate: 0,
					codeType: QrCodeType.QrCode,
				});
				// getDrawLabelLine	（x坐标，y坐标，线条宽度，线条高度，旋转角度，线条类型）
				// 绘制横线 实线8条
				this.getDrawLabelLine(1, 1, 67, 0.5, 0, LineType.Solid)
				this.getDrawLabelLine(1, 6, 42, 0.3, 0, LineType.Solid)
				this.getDrawLabelLine(1, 11, 42, 0.3, 0, LineType.Solid)
				this.getDrawLabelLine(1, 16, 42, 0.3, 0, LineType.Solid)
				this.getDrawLabelLine(1, 21, 42, 0.3, 0, LineType.Solid)
				this.getDrawLabelLine(1, 27, 67, 0.3, 0, LineType.Solid)
				this.getDrawLabelLine(1, 32, 67,0.3, 0, LineType.Solid)
				this.getDrawLabelLine(1, 37, 67, 0.3, 0, LineType.Solid)
				this.getDrawLabelLine(1, 42, 67, 0.3, 0, LineType.Solid)
				this.getDrawLabelLine(1, 47, 67, 0.5, 0, LineType.Solid)
				//绘制竖线
				this.getDrawLabelLine(1, 1, 0.5, 46, 0, LineType.Solid) // 竖线1
				this.getDrawLabelLine(43, 1, 0.3, 26, 0, LineType.Solid) // 竖线2
				this.getDrawLabelLine(68, 1, 0.5, 46, 0, LineType.Solid) // 竖线2
				// getDrawLabelText	（1.x坐标，2.y坐标，3.文本框宽度，4.文本框高度，5.绘制文字内容，6.字体大小（默认高度4mm）,7.旋转角度,8.换行方式,9.⾏间隔,10.字间隔,11.文字水平布局,12文字垂直布局)
				// 标题
				this.getDrawLabelText(3, 2.5, 40, 8, '中天科技装箱清单', 2.5, 0, LineModeType.AutoHeight, 0, 0, 1, 1,1)
				// 填冲文字标题
				this.getDrawLabelText(2, 7, 25, 8, '合同号:', 2.5, 0, LineModeType.AutoHeight, 0, 0, 0, 1,1)
				this.getDrawLabelText(2, 12, 25, 8, '零件号:', 2.5, 0, LineModeType.AutoHeight, 0, 0, 0, 1,1)
				this.getDrawLabelText(2, 17, 25, 8, '零件描述:', 2.5, 0, LineModeType.AutoHeight, 0, 0, 0, 1,1)
				this.getDrawLabelText(2, 22.5, 25, 8, '发货/装箱数:', 2.5, 0, LineModeType.AutoHeight, 0, 0, 0, 1,1)
				this.getDrawLabelText(2, 27.5, 25, 8, '生产日期:', 2.5, 0, LineModeType.AutoHeight, 0, 0, 0, 1,1)
				this.getDrawLabelText(2, 32.5, 25, 8, '生产批号:', 2.5, 0, LineModeType.AutoHeight, 0, 0, 0, 1,1)
				this.getDrawLabelText(2, 37.5, 25, 8, '发货单位:', 2.5, 0, LineModeType.AutoHeight, 0, 0, 0, 1,1)
				this.getDrawLabelText(2, 42.5, 25, 8, '收货单位:', 2.5, 0, LineModeType.AutoHeight, 0, 0, 0, 1,1)
				// 填冲参数值
				this.getDrawLabelText(11, 7, 30, 8, ht, 2.5, 0, LineModeType.AutoHeight, 0, 0, 0, 0,1)
				this.getDrawLabelText(11, 12, 32, 8, lj, 2.5, 0, LineModeType.AutoHeight, 0, 0, 0, 0,1)
				this.getDrawLabelText(14, 17, 30, 8, ljms, 2.5, 0, LineModeType.AutoHeight, 0, 0, 0, 0,1)
				this.getDrawLabelText(17, 22.5, 27, 8, fh, 2.5, 0, LineModeType.AutoHeight, 0, 0, 0, 0,1)
				this.getDrawLabelText(14, 27.5, 55, 8, scdt, 2.5, 0, LineModeType.AutoHeight, 0, 0, 0, 0,1)
				this.getDrawLabelText(14, 32.5, 55, 8, scph, 2.5, 0, LineModeType.AutoHeight, 0, 0, 0, 0,1)
				this.getDrawLabelText(14, 37.5,55, 8, fhdw, 2.5, 0, LineModeType.AutoHeight, 0, 0, 0, 0,1)
				this.getDrawLabelText(14, 42.5, 55, 8, shdw, 2.5, 0, LineModeType.AutoHeight, 0, 0, 0, 0,1)

				// 生成打印数据
				let imageJsonObj = jcapi.generateLabelJson()
				let imageJsonObj111 = jcapi.generatePrintPreviewImage(imageJsonObj)
				console.log('预览', imageJsonObj111)
				// // 设置打印任务
				jcapi.startJob({
					totalCount: 1,
					density: this.printDensity,
					labelType: this.labelType,
					printMode: this.printMode,
				}, function(r) {
					console.log('打印', r)
					if (r.code == 0) {
						// 打印数据
						jcapi.printData(imageJsonObj, {
							"printQuantity": 1,
						}, function(r) {
							if (r.code == 0) {
								console.log("打印成功")
								uni.showToast({
									title: '打印成功',
									icon: 'success'
								})
							} else {
								console.log("打印失败")
								uni.showToast({
									title: '打印失败: ' + (r.msg || '未知错误'),
									icon: 'none'
								})
							}
						})
					} else {
						console.log("设置打印任务失败")
					}

				})

			},
			tapQuery(item) {
				this.maskShow = false
				// 连接打印机
				let _this = this;
				console.log(item)
				jcapi.openPrinterByDevice({
					address: item.address,
					name: item.name,
					deviceType: 0 // 设备类型：0-蓝牙，1-网络
				}, function(r) {
					uni.showToast({
						title: (r.code == 0) ? "连接成功" : "连接失败",
						duration: 2 * 1000
					})
					if (r.code == 0) {
						_this.connectedDevice = item
						// 添加打印列表空值检查
						if (!_this.pritList || _this.pritList.length === 0) {
							uni.showToast({
								title: '没有可打印的数据',
								icon: 'none'
							})
							return
						}
						// 绘标签进行打印
						_this.pritList.forEach(async item => {
							await _this.printQrCode(item)
						})
					}
				})
			},
			//打印相关
			searchDevice() {
				let _this = this
				uni.openBluetoothAdapter({ // 确认蓝牙是否打开
					success(r) {
						uni.showLoading({
							title: "搜索中..."
						})
						// 未授予蓝牙相关权限和未打开手机定位会搜索不到设备
						jcapi.getBluetoothDevices(function(r) {
							console.log("device:" + JSON.stringify(r))
							// 搜索到设备回调
							uni.hideLoading()
							// 如果之前有连接的设备但不在搜索结果中，说明设备已更换
							if (_this.connectedDevice && !r.some(dev => dev.address === _this.connectedDevice.address)) {
								_this.connectedDevice = null;
								uni.showToast({
									icon: 'none',
									title: '已连接的蓝牙设备已更换，请重新选择',
									duration: 2000
								});
							}
							_this.listDevice = r;
							_this.maskShow = true
						})
					},
					fail(e) {
						uni.showModal({
							title: '提示',
							content: '打开蓝牙失败，请检查蓝牙是否开启',
							showCancel: false
						})
						console.log("开启蓝牙设备失败" + e)
					}
				})
			},
			// 绘制横线 实线
			getDrawLabelLine(x, y, width, height, rotate, lineType) {
				jcapi.drawLabelLine({
					x: x,
					y: y,
					width: width,
					height: height,
					rotate: rotate,
					lineType: lineType
				});
			},
			// 填冲文字标题
			getDrawLabelText(x, y, width, height, value, fontSize, rotate, lineMode, lineSpace, letterSpace,
				textAlignHorizontal, textAlignVertical,bold) {

				jcapi.drawLabelText({
					x: x,
					y: y,
					width: width,
					height: height,
					value: value,
					fontSize: fontSize,
					rotate: rotate,
					lineMode: lineMode,
					lineSpace: lineSpace,
					letterSpace: letterSpace,
					textAlignHorizontal: textAlignHorizontal,
					textAlignVertical: textAlignVertical,
					bold:bold
				})
			},

			//刷新上一个页面
			refreshLastPage(no) {
				// 告知 A.vue 更新数据
				// 获取页面栈
				let pages = getCurrentPages()

				// 获取上一页栈
				let prevPage = pages[pages.length - 2]

				// 触发上一页 upData 函数(并携带参数)
				prevPage.$vm.setNo(no)

				// 返回上一页
				uni.navigateBack({
					delta: 1
				})
			},
		}
	};
</script>
<style lang="scss">
	.finishProductIn-locno-bg {
		background-color: #F6F9FF;
		background-image: url('~@/static/custom/finishProductIn/locNoBg.png');
		// background: linear-gradient(180deg,rgba(206,227,254,1),rgba(206,227,254,1) 20%,rgba(206,227,254,0.5) 40%,rgba(206,227,254,0.25) 60%,rgba(206,227,254,0.08) 80%,rgba(206,227,254,0));
		padding: 0 20rpx;
		background-attachment: fixed;
		background-size: 100% auto;
		background-repeat: no-repeat;
		position: fixed;
		top: 0;
		bottom: 0;
		width: 100%;
		z-index: -1;
	}

	.finishProductIn-locno-search {
		padding: 40rpx 30rpx 20rpx 30rpx;
	}

	.wrap .finishProductIn-locno-scroll-list {
		height: calc(100vh - var(--window-top) - var(--window-bottom) - 242rpx);
		width: 100%;
	}

	.finishProductIn-locno-scroll-list-group {
		::v-deep .u-cell-item-box {
			background-color: rgba(250, 252, 255, 0.36) !important;
			padding: 0rpx 30rpx;
		}

		.content {
			font-size: 12px;
			background-color: #ffffff;
			box-sizing: border-box;
			border-radius: 10rpx;
			margin: 0rpx 0rpx 16rpx;
			padding: 20rpx 8rpx;
			box-shadow: none;
			display: flex;
			align-items: center;

			.content-header {
				width: 40rpx;
				height: 90rpx;
				display: flex;
				align-items: center;

				.content-header-icon {
					background-image: url("~@/static/custom/moveWareHouse/header_icon.png");
					background-size: 100% auto;
					background-repeat: no-repeat;
					height: 28rpx;
					width: 28rpx;
				}

				.content-header-title {
					margin-left: 11rpx;
					font-size: 26rpx;
					font-weight: bold;
					color: #3d52f5;
				}
			}

			.content-body {
				flex: 1;
				background: #f5f9ff;
				border-radius: 10rpx;
				padding: 0rpx 23rpx;

				.row-list {
					height: 60rpx;
					display: flex;
					flex-direction: row;
					padding: 0px;
					align-items: center;
				}

				.row-list ._label {
					display: flex;
					flex: 0.8;
					color: #909399;
					align-items: center;

					._label-icon-1 {
						background-image: url("~@/static/custom/moveWareHouse/label-icon-1.png");
						background-size: 100% auto;
						background-repeat: no-repeat;
						height: 26rpx;
						width: 26rpx;
					}

					._label-icon-2 {
						background-image: url("~@/static/custom/moveWareHouse/label-icon-2.png");
						background-size: 100% auto;
						background-repeat: no-repeat;
						height: 26rpx;
						width: 26rpx;
					}

					._label-icon-3 {
						background-image: url("~@/static/custom/moveWareHouse/label-icon-3.png");
						background-size: 100% auto;
						background-repeat: no-repeat;
						height: 26rpx;
						width: 26rpx;
					}

					._label-name {
						margin-left: 11rpx;
						font-size: 26rpx;
						font-weight: 500;
						color: #666666;
					}
				}

				.row-list ._content {
					flex: 1.5;
					text-align: right;
					color: #909399;
					font-size: 24rpx;
				}

				.row-list .s1 {
					color: #d35651;
				}
			}
		}
	}

	.navbar-right {
		font-weight: 500;
		font-size: 13px;
		color: #0b0b0b;
		line-height: 36rpx;
		margin-right: 32rpx;
	}
</style>